<template>
	<router-view tag="main"/>
</template>

<style>
main > div,
main > section {
	background: var(--main-2);
	padding: 1rem;
}
</style>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator"
import store from "../store"

@Component({
	async beforeRouteEnter (to, from, next) {
		if (!store.getters.isLoggedIn) {
			next({name: "login"})
		} else if (!store.getters.checkedSession && store.getters.isLoggedIn) {
			if (store.getters.isExpired()) {
				store.commit("session", {})
				next({name: "login", params: {expired: "true"}})
			} else {
				const req = new Request(`${process.env.VUE_APP_API}/vault/session`, {
					method: "GET",
					mode: "cors",
					cache: "no-cache",
					redirect: "follow",
					referrer: "no-referrer",
					headers: {
						"Accept": "application/json",
						"X-VAULT-SESSION": store.state.session.sessionKey,
						"X-VAULT-TOKEN": store.state.session.secretKey,
					},
				})

				let rawResponse

				try {
					rawResponse = await fetch(req)
				} catch (err) {
					console.error(err)
					next({name: "net-error"})
					return
				}

				switch (rawResponse.status) {
				case 410:
					store.commit("session", {})
					next({name: "login", params: {expired: "true"}})
					return
				case 403:
					store.commit("session", {})
					next({name: "login", params: {expired: "ip"}})
					return
				}

				const json = await rawResponse.json()

				if (Reflect.has(json, "session")) {
					// update the expiration
					store.commit("expiry", json.session.expires)
				}

				// first page navigation
				await store.commit("checkedSession")
				next()
			}
		} else {
			next()
		}
	},
})
export default class Vault extends Vue {
	timer?: number

	beforeCreate () {
		if (!this.$store.getters.isLoggedIn) {
			this.$router.push({name: "login"})
			return
		} else if (this.$store.getters.isExpired()) {
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		}
	}

	mounted () {
		if (!this.timer) {
			this.timer = self.setTimeout(this.autoLogout, this.$store.getters.timeLeft())
		}
	}

	autoLogout () {
		// inactivity logout
		const timeLeft = this.$store.getters.timeLeft()
		if (timeLeft > 10 && this.timer) {
			// reset the timer
			clearTimeout(this.timer)
			this.timer = self.setTimeout(this.autoLogout, timeLeft)
			return
		}

		this.$router.push({name: "login", params: {expired: "true"}})
	}
}
</script>
